; Assembly Source File
; Created 4/2/2002, 3:59:07 PM
 
 include "os.h"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;my macros... these aren't found in os.h at the moment...        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;this macro requires that a4 be initialized with move.l $c8,a4
;prior to its use
ROM_CALL3 macro
 move.l \1*4(a4),a0
 jsr (a0)
 endm
 
;this macro makes use of the line 1111 emulator for making rom calls... 
ROM_CALLF macro
 dc.w $F800+\1
 endm

;makes use of the line 1010 emulator... error codes are those listed in the calc's guide book...
ERR_THROW macro
 dc.w $A000+\1
 endm

 ifnd ClrScr
 ClrScr equ $19E
 endc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Code begins here...       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	section ".data"
	xdef Exception_1
	xdef Exception_2
	xdef Exception_3
	xdef Exception_4
	xdef Exception_5
	xdef Exception_6
	xdef Exception_7
	xdef Exception_8
	xdef Exception_9
	xdef Exception_10
	xdef Exception_11
	xdef Exception_12
	xdef Exception_13
	xdef Exception_14
	xdef Exception_15

.even

;Exception Handlers - Put exception number and type on the stack
Exception_1:
 move.w #$0000,-(sp)
 bra.s FinishUp
 
Exception_2:
 move.w #$0101,-(sp)
 bra.s FinishUp
 
Exception_3:
 move.w #$0202,-(sp)
 bra.s FinishUp
 
Exception_4:
 move.w #$0203,-(sp)
 bra.s FinishUp
 
Exception_5:
 move.w #$0204,-(sp)
 bra.s FinishUp
 
Exception_6:
 move.w #$0105,-(sp)
 bra.s FinishUp

Exception_7:
 move.w #$0106,-(sp)
 bra.s FinishUp

Exception_8:
 move.w #$0107,-(sp)
 bra.s FinishUp

Exception_9:
 move.w #$0108,-(sp)
 bra.s FinishUp

Exception_10:
 move.w #$0209,-(sp)
 bra.s FinishUp

Exception_11:
 move.w #$020a,-(sp)
 bra.s FinishUp

Exception_12:
 move.w #$020b,-(sp)
 bra.s FinishUp

Exception_13:
 move.w #$020c,-(sp)
 bra.s FinishUp

Exception_14:
 move.w #$020d,-(sp)
 bra.s FinishUp

Exception_15:
 move.w #$020e,-(sp)
 
;finish handling the error...
FinishUp:
 move.w #$6700,sr		;disable interrupts, keep supervisor mode, prepare to check for vti
 movem.l d0-d7/a0-a6,-(sp)	;save registers
 move.l usp,a0
 move.l a0,-(sp)		;save user stack pointer
 tst.b 64(sp)
 bne.s Skip_VTI_Check		;only need to check for vti if an address or bus error was found
 move.b sr,d0
 btst.w #14,d0
 beq.s VTI_Not_Detected		;detect VTI
 move.b #$04,64(sp)		;I'm calling this frame 4 (same format as 1 & 2)... VTI stacks incorrect Address Error (& Probabbly incorrect Bus Error) frames
Skip_VTI_Check:
VTI_Not_Detected:
 move.w #(16+6),-(sp)
 pea.l __gOldVectors
 pea.l __gVectors
 jsr InstallExceptionVectors
 lea.l 10(sp),sp
 move.l $c8,a4
 ROM_CALL3 PortRestore		;in case the screen isn't using LCD_MEM. grayscale etc...
 movea.l __gCrashHandler(pc),a5
 cmpa.l #0,a5
 beq.s NoHUD			;check if __gCrashHandler points to a function

;i thought that running supervisor mode, no interrupts was limiting, so i've changed it ;)
 move.l sp,a0			;put the address of the supervisor stack in a0 for the HUD function
 move $0,sr			;change to user mode, allow interrupts
 jsr (a5)			;The HUD function is executed in user mode, interrupts enabled
 trap #$c			;switch back to supervisor mode to clear off stack
 move #$2700,sr			;supervisor mode, no interrupts
 
NoHUD:
 tst.b 64(sp)
 bne.s ShortStackFormat
 lea.l 8(sp),sp			;long format is 14 bytes
ShortStackFormat:
 lea.l 66(sp),sp		;(15_registers*4)+2_eindex+4_a7+(6_short frame format)		
 move #$700,sr			;user mode (important for more info see ER_catch)
 ERR_THROW $6

